//+------------------------------------------------------------------+
//|                                                   ADX Trader.mq4 |
//|                                                   Amritendu Maji |
//+------------------------------------------------------------------+
#property copyright "Amritendu Maji"
#property link      "None"

extern int MagicNumber=283287;

extern double Lots=0.1;
extern int Slippage=3;
extern int MaxTrades=1;
extern bool MM = false; //Use Money Management or not
extern int Risk = 5; //10%

extern int StopLoss=100;
extern int TakeProfit=1000; 

extern int ADXPeriod=14;
extern double ADXLevel=20;

extern int TimeFrame=60;

bool runnable=true;
bool initialize=true;
string EAName = "ADX Trader";
datetime timeprev=0;
bool BC1, BC2, BC3, SC1, SC2, SC3;

int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{
//Runnable
 if(runnable!=true)
  return(-1);
  
 
//
//Close/Open
//
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 
 
//
//Calculations
//
 double ADX1=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MAIN,1); 
 double ADX2=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MAIN,2); 
 double DIPlus1=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,1); 
 double DIMinus1=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,1); 
 double DIPlus2=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,2); 
 double DIMinus2=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,2); 
  
 if(MM==true) Lots = LotSize();
 
 if (DIPlus1 > DIMinus1)
 {
  BC1 = true;
  SC1 = false;
 }
 else
 {
  BC1 = false;
  SC1 = true;
 }
 
 if (DIPlus1 > ADXLevel)
 {
  BC2 = true;
 }
 else
 {
  BC2 = false;
 }

 if (DIMinus1 > ADXLevel)
 {
  SC2 = true;
 }
 else
 {
  SC2 = false;
 }
 
 if (ADX1 > ADXLevel)
 {
  BC3 = true;
  SC3 = true;
 }
 else
 {
  BC3 = false;
  SC3 = true;
 }


//
//Trade
//

//Long
 if(BC1 && BC2 && BC3 && (CountOpenTrades()<MaxTrades))
 {
  CloseShorts();
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(Bid,StopLoss),TakeLong(Ask,TakeProfit),EAName,MagicNumber,0,Blue);
 }//Long
 
//Shrt
 if(SC1 && SC2 && SC3 && (CountOpenTrades()<MaxTrades))
 {
  CloseLongs();
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShrt(Ask,StopLoss),TakeShrt(Bid,TakeProfit),EAName,MagicNumber,0,Red);
 }//Shrt
 
 
//Close Long
 if(DIPlus1 < ADXLevel && ADX1 < ADXLevel)
 {
  CloseLongs();
 }//Close Long
 
 //Close Short
 if(DIMinus1 < ADXLevel && ADX1 > ADXLevel)
 {
  CloseShorts();
 }//Close Short

 return(0);
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShrt(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShrt(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}



void CloseLongs()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(OrderSelect(trade,SELECT_BY_POS,MODE_TRADES)==false)
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_BUY)
   OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
 }//for
}

void CloseShorts()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(OrderSelect(trade,SELECT_BY_POS,MODE_TRADES)==false)
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_SELL)
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
 }//for
}

int CountOpenTrades()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if((OrderType()==OP_SELL) || (OrderType()==OP_BUY))
   count++;
 }//for
 return(count);
}

double LotSize()
{
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
   if (lotMM < 0.1) lotMM = Lots;
//   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 



